Bug 1918012 - oc adm catalog mirror ignore index image push all image into mirror
Summary: oc adm catalog mirror ignore index image push all image into mirror
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: OLM
Version: 4.6
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: ---
: 4.6.z
Assignee: Evan Cordell
QA Contact: Bruno Andrade
URL:
Whiteboard:
Depends On: 1904297
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-01-19 20:15 UTC by OpenShift BugZilla Robot
Modified: 2021-02-22 13:54 UTC (History)
12 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-02-22 13:54:32 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github operator-framework operator-registry pull 560 0 None closed [release-4.6] Bug 1918012: Unexpected images left in `related_images` after pruning 2021-02-14 00:45:18 UTC
Red Hat Product Errata RHBA-2021:0510 0 None None None 2021-02-22 13:54:42 UTC

Comment 3 Bruno Andrade 2021-02-15 13:47:57 UTC
bin/opm version
Version: version.Version{OpmVersion:"v1.16.0", GitCommit:"eb9fff53", BuildDate:"2021-02-15T01:52:20Z", GoOs:"linux", GoArch:"amd64"}

1, Prune the registry.redhat.io/redhat/redhat-operator-index:v4.6 to keep cluster-logging only. And, push it.

./bin/opm index prune -f registry.redhat.io/redhat/redhat-operator-index:v4.6 -p clus
INFO[0059] writing dockerfile: index.Dockerfile143286808  packages="[cluster-logging]"
INFO[0059] running podman build                          packages="[cluster-logging]"
INFO[0059] [podman build --format docker -f index.Dockerfile143286808 -t quay.io/olmqe/redhat-operator-index:v4.6-2 .]  packages="[cluster-logging]"

podman push quay.io/olmqe/redhat-operator-index:v4.6-2
Getting image source signatures

2, Check the database. There is no related images, looks good.
podman create quay.io/olmqe/redhat-operator-index:v4.6-2
5ef841aeae0edf39cb38922caa6d20e61c58024a871ba25055b149b6648346a0

podman cp 46ea17a69db19e57bd5e8e0c44126bbcac074c32ffa851c3f64f01b83bc275e2:/database/index.db logging.db

sqlite3  logging.db "select distinct(operatorbundle_name) from related_image where operatorbundle_name not in (select operatorbundle_name from channel_entry) order by 1;"

3, check the image mirroring mapping.
oc adm catalog mirror quay.io/olmqe/redhat-operator-index:v4.6-2 localhost:5000 --manifests-only
src image has index label for database path: /database/index.db
using database path mapping: /database/index.db:/tmp/354694744
wrote database to /tmp/354694744
using database at: /tmp/354694744/index.db
no digest mapping available for quay.io/olmqe/redhat-operator-index:v4.6-2, skip writing to ImageContentSourcePolicy
wrote mirroring manifests to manifests-redhat-operator-index-1711212950

tree manifests-redhat-operator-index-1711212950
manifests-redhat-operator-index-1711212950
├── catalogSource.yaml
├── imageContentSourcePolicy.yaml
└── mapping.txt


cat manifests-redhat-operator-index-1611212950/catalogSource.yaml 
apiVersion: operators.coreos.com/v1alpha1
kind: CatalogSource
metadata:
  name: redhat-operator-index
  namespace: openshift-marketplace
spec:
  image: localhost:5000/olmqe/redhat-operator-index:v4.6-2
  sourceType: grpc

cat manifests-redhat-operator-index-1611212950/imageContentSourcePolicy.yaml 
apiVersion: operator.openshift.io/v1alpha1
kind: ImageContentSourcePolicy
metadata:
  name: redhat-operator-index
spec:
  repositoryDigestMirrors:
  - mirrors:
    - localhost:5000/openshift4/ose-logging-curator5
    source: registry.redhat.io/openshift4/ose-logging-curator5
  - mirrors:
    - localhost:5000/openshift4/ose-logging-fluentd
    source: registry.redhat.io/openshift4/ose-logging-fluentd
  - mirrors:
    - localhost:5000/openshift4/ose-cluster-logging-operator-bundle
    source: registry.redhat.io/openshift4/ose-cluster-logging-operator-bundle
  - mirrors:
    - localhost:5000/openshift4/ose-cluster-logging-operator
    source: registry.redhat.io/openshift4/ose-cluster-logging-operator

cat manifests-redhat-operator-index-1711212950/mapping.txt 
registry.redhat.io/openshift4/ose-logging-curator5@sha256:73884604ac4506bcfb2a3c112eb621f40e0cd53fede8118e0f7a1b292ac8f924=localhost:5000/openshift4/ose-logging-curator5:f6789123
registry.redhat.io/openshift4/ose-logging-fluentd@sha256:11ccb42f3d96b065f7d94879611a7aefabbe509b522c11ac36be7a1c959a34d6=localhost:5000/openshift4/ose-logging-fluentd:1f0b20f7
registry.redhat.io/openshift4/ose-cluster-logging-operator-bundle@sha256:61aca61840dcf1d50f4a17fc9b2e10b7855c563bd6680b4dc77e3e9283c81369=localhost:5000/openshift4/ose-cluster-logging-operator-bundle:8f6d6578
registry.redhat.io/openshift4/ose-cluster-logging-operator@sha256:540b0d087c5e5529bab555030310478630249a9339a4a4c3fac6d0d7037d5eac=localhost:5000/openshift4/ose-cluster-logging-operator:5f9e513e
quay.io/olmqe/redhat-operator-index:v4.6-2=localhost:5000/olmqe/redhat-operator-index:v4.6-2


Only "cluster-logging" related images list, looks good to me, verify it.

Comment 5 errata-xmlrpc 2021-02-22 13:54:32 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory (OpenShift Container Platform 4.6.18 bug fix update), and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2021:0510


Note You need to log in before you can comment on or make changes to this bug.